/*
   This library is free software; you can redistribute it and/or
   modify it under the terms of the GNU Library General Public
   License version 2 as published by the Free Software Foundation.

   This library is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
   Library General Public License for more details.

   You should have received a copy of the GNU Library General Public License
   along with this library; see the file COPYING.LIB.  If not, write to
   the Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
   Boston, MA 02110-1301, USA.
*/

#ifndef PLASMAX2GODIALOG_H
#define PLASMAX2GODIALOG_H

#include <QObject>
#include <QString>
#include <QGraphicsLinearLayout>
#include <QProcess>

class x2goplasmoid;
class QGraphicsWidget;

class PlasmaX2goDialog : public QObject
{
	Q_OBJECT
public:
	explicit PlasmaX2goDialog(QObject* parent = 0);
	virtual ~PlasmaX2goDialog();
	QGraphicsWidget* dialog()
	{ return m_widget;}
protected:
	bool eventFilter(QObject *obj, QEvent *event);
private:
	void initDialog();
	void updateMountedItems(QStringList newItems);
	void removeItem(QString item);
	void appendItem(QString item);
	QStringList mountedItems();

	QGraphicsWidget* m_widget;
	x2goplasmoid* m_applet;
	QGraphicsLinearLayout* itemLayout;
	QProcess *updateItemProc;
	QGraphicsWidget* itemWidget;

private slots:
	void slotSuspendSession();
	void slotUpdateItems();
	void slotUpdateItemsProcFinished(int exitCode, QProcess::ExitStatus exitStatus);
	void slotOpenFolder(const QString& folder);
	void slotEjectFolder(const QString& folder);
};

#endif // PLASMAX2GODIALOG_H
